﻿/* Copyright (c) 2015 Rick (rick 'at' gibbed 'dot' us)
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software
 *    in a product, an acknowledgment in the product documentation would
 *    be appreciated but is not required.
 * 
 * 2. Altered source versions must be plainly marked as such, and must not
 *    be misrepresented as being the original software.
 * 
 * 3. This notice may not be removed or altered from any source
 *    distribution.
 */

namespace Gibbed.Cryptic.FileFormats.Parser
{
    public enum TokenType : byte
    {
        Ignore = 0,
        Start = 1,
        End = 2,

        Byte = 3,
        Int16 = 4,
        Int32 = 5,
        Int64 = 6,
        Float = 7,
        String = 8,
        CurrentFile = 9,
        Timestamp = 10,
        LineNumber = 11,
        Boolean = 12,
        NoAST = 13,
        BooleanFlag = 14,
        QUATPYR = 15,
        MATPYR = 16,
        Filename = 17,
        Reference = 18,
        FunctionCall = 19,
        Structure = 20,
        Polymorph = 21,
        StashTable = 22,
        Bit = 23,
        MultiValue = 24,
        Command = 25,
    }
}
